SystemOrganization addCategory: 'OrbeonBPMCore'!

Object subclass: #BpmObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmObject subclass: #BpmArtifactDefinition
	instanceVariableNames: 'processDefinition name inTransitions outTransitions roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmArtifactDefinition subclass: #BpmActivityDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmActivityDefinition subclass: #BpmAbstractTaskDefinition
	instanceVariableNames: 'loop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 13:30'!
hasLoop

	^loop notNil! !

!BpmAbstractTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 13:30'!
loop
	^loop! !

!BpmAbstractTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/01/2015 13:30'!
loop: newValue
	loop := newValue! !

BpmAbstractTaskDefinition subclass: #BpmSubProcessTaskDefinition
	instanceVariableNames: 'subProcessDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addSubProcessTask: self! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:38'!
instanceClass

	^BpmProcessInstance! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:15'!
printOnType

	^'S'! !

!BpmSubProcessTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:10'!
subProcessDefinition
	^subProcessDefinition! !

!BpmSubProcessTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:10'!
subProcessDefinition: newValue
	subProcessDefinition := newValue! !

BpmAbstractTaskDefinition subclass: #BpmTaskDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addTask: self! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:39'!
instanceClass

	^BpmOrbeonTaskInstance! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:15'!
printOnType

	^'T'! !

BpmActivityDefinition subclass: #BpmGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmGatewayDefinition subclass: #BpmComplexGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmComplexGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:36'!
instanceClass

	^BpmComplexGateway! !

BpmGatewayDefinition subclass: #BpmEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmEventBasedGateway! !

BpmGatewayDefinition subclass: #BpmExclusiveEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExclusiveEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmExclusiveEventBasedGateway! !

BpmGatewayDefinition subclass: #BpmExclusiveGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmExclusiveGateway! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addGateway: self! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'G'! !

BpmGatewayDefinition subclass: #BpmInclusiveGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmInclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:40'!
instanceClass

	^BpmInclusiveGateway! !

BpmGatewayDefinition subclass: #BpmParallelEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParallelEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:35'!
instanceClass

	^self subclassResponsibility! !

BpmGatewayDefinition subclass: #BpmParallelGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParallelGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:38'!
instanceClass

	^BpmParallelGateway! !

!BpmArtifactDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:41'!
process: aBpmProcessDefinition

	^super new initialize
		processDefinition: aBpmProcessDefinition;
		yourself! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:23'!
addInTransition: aBpmTransitionDefinition

	^inTransitions add: aBpmTransitionDefinition! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:23'!
addOutTransition: aBpmTransitionDefinition

	^outTransitions add: aBpmTransitionDefinition! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:21'!
addToParentProcess

	^self subclassResponsibility! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:32'!
createInstance

	^self subclassResponsibility! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:19'!
grantRole: aBpmRole

	^roles add: aBpmRole! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:22'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.
	roles := OrderedCollection new.! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:34'!
instanceClass

	^self subclassResponsibility! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 11:57'!
inTransitions
	^inTransitions! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 11:57'!
inTransitions: newValue
	inTransitions := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 05:54'!
isGrantedRole: aBpmRole

	^roles includes: aBpmRole! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:33'!
isGrantedRoleNamed: aString

	^roles anySatisfy: [:each | each name = aString]! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 16:14'!
name
	^name! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 16:14'!
name: newValue
	name := newValue! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 11:57'!
outTransitions
	^outTransitions! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 11:57'!
outTransitions: newValue
	outTransitions := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:16'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ' (', self printOnType, ') [', name, ']'.! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:13'!
printOnType

	^'Art'! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 16:14'!
processDefinition
	^processDefinition! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 16:14'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:22'!
roles
	^roles! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:22'!
roles: newValue
	roles := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:19'!
ungrantRole: aBpmRole

	^roles remove: aBpmRole ifAbsent: []! !

BpmArtifactDefinition subclass: #BpmEventDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmEventDefinition subclass: #BpmEndEventDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmEndEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:26'!
addToParentProcess

	^processDefinition addEndEvent: self! !

!BpmEndEventDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:35'!
instanceClass

	^BpmEndEventInstance! !

!BpmEndEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'ev:end'! !

BpmEventDefinition subclass: #BpmIntermediateEventDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmIntermediateEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:26'!
addToParentProcess

	^processDefinition addIntermediateEvent: self! !

!BpmIntermediateEventDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:36'!
instanceClass

	^BpmIntermediateEventInstance! !

!BpmIntermediateEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'ev:in'! !

BpmEventDefinition subclass: #BpmStartEventDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmStartEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:26'!
addToParentProcess

	^processDefinition startEvent: self! !

!BpmStartEventDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:35'!
instanceClass

	^BpmStartEventInstance! !

!BpmStartEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'ev:start'! !

BpmObject subclass: #BpmCodeAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmObject subclass: #BpmCodeCondition
	instanceVariableNames: 'evaluationCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmCodeCondition class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:10'!
code: aString

	^super new initialize
		evaluationCode: aString;
		yourself! !

!BpmCodeCondition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 13:10'!
evaluationCode
	^evaluationCode! !

!BpmCodeCondition methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 13:10'!
evaluationCode: newValue
	evaluationCode := newValue! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:30'!
printEvaluationCode

	evaluationCode ifNil: [^'none'].

	^evaluationCode! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:27'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '{', self printEvaluationCode, '}'! !

BpmObject subclass: #BpmParticipantDefinition
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParticipantDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 15:45'!
name
	^name! !

!BpmParticipantDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 15:45'!
name: newValue
	name := newValue! !

!BpmParticipantDefinition methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 16:32'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[',name, ']'.! !

BpmParticipantDefinition subclass: #BpmResourceParticipantDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmParticipantDefinition subclass: #BpmRoleParticipantDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmObject subclass: #BpmProcessDefinition
	instanceVariableNames: 'id processName sheetName executionPath roles processInstances orbeonApplication version parentProcess subProcesses formFieldInstances participants xmlString'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 09:23'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 09:23'!
initializeCache

	Cache := Dictionary new! !

!BpmProcessDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:28'!
newNamed: aString

	^super new initialize
		processName: aString;
		yourself! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 16:43'!
addAllParticipants: aCollection

	^aCollection do: [:bpmParticipant | participants at: bpmParticipant name put: bpmParticipant]! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:27'!
addEndEvent: aBpmEndEventDefinition

	^executionPath addEndEvent: aBpmEndEventDefinition! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:20'!
addGateway: aBpmGatewayDefinition

	^executionPath addGateway: aBpmGatewayDefinition! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:27'!
addIntermediateEvent: aBpmIntermediateEventDefinition

	^executionPath addIntermediateEvent: aBpmIntermediateEventDefinition! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:20'!
addSubProcessTask: aBpmSubProcessTaskDefinition

	^executionPath addSubProcessTask: aBpmSubProcessTaskDefinition! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:20'!
addTask: aBpmTaskDefinition

	^executionPath addTask: aBpmTaskDefinition! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 09:33'!
addToCache
	"Add the receiver to the global cache for this class"
	| processesDictionary processDefinitions |

	(processName isNil or:[processName isEmpty]) ifTrue: [^NoProcessNameException signal: 'ProcessDefinition MUST have a name'].
	orbeonApplication ifNil: [^NoOrbeonAppException signal: 'ProcessDefinition MUST have anOrbeonApplication'].

	processesDictionary := (self class cache includesKey: orbeonApplication app) "get the dictionary of processes"
			ifTrue: [self class cache at: orbeonApplication app]
			ifFalse: [self class cache at: orbeonApplication app put: Dictionary new].

	processDefinitions := (processesDictionary includesKey: processName) "get the collection of versions for definition named <processName>"
			ifTrue: [processesDictionary at: processName] 
			ifFalse: [processesDictionary at: processName put: OrderedCollection new].

	processDefinitions isEmpty 
	ifFalse: [(version = (processDefinitions last version + 1)) 
		ifFalse: [^BrokenVersionChainException signal: 'The new version [', version printString, '] broke the previous version chain [', processDefinitions last version printString, ']. Version should be [', (processDefinitions last version + 1) printString, ']']]
	ifTrue: [(version = 1) ifFalse: [^BrokenVersionChainException signal: 'This is the first version must be version [1] ']].

	processDefinitions add: self.! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:21'!
addTransition: aBpmTransitionDefinition

	^executionPath addTransition: aBpmTransitionDefinition! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 14:48'!
createProcessInstance: aBpmUser
	"Create a new process instance based on the receiver"
	| newProcess |

	newProcess := BpmProcessInstance definition: self user: aBpmUser.

	^newProcess! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:39'!
executionPath
	^executionPath! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:39'!
executionPath: newValue
	executionPath := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
formFieldInstances
	^formFieldInstances! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
formFieldInstances: newValue
	formFieldInstances := newValue! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:14'!
getEndEventNamed: aString ifNone: aBlock

	^executionPath getEndEventNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:14'!
getGatewayNamed: aString ifNone: aBlock

	^executionPath getGatewayNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:14'!
getIntermediateEventNamed: aString ifNone: aBlock

	^executionPath getIntermediateEventNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfEndEvents

	^executionPath getNumberOfEndEvents! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfGateways

	^executionPath getNumberOfGateways! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfIntermediateEvents

	^executionPath getNumberOfIntermediateEvents! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfSubProcessTasks

	^executionPath getNumberOfSubProcessTasks! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfTasks

	^executionPath getNumberOfTasks! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfTransitions

	^executionPath getNumberOfTransitions! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:14'!
getSubProcessTaskNamed: aString ifNone: aBlock

	^executionPath getSubProcessTaskNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/30/2015 12:31'!
getSubProcessTasks

	^executionPath subProcessTasks! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:15'!
getTaskNamed: aString ifNone: aBlock

	^executionPath getTaskNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/30/2015 05:43'!
getTransitionNamed: aString ifNone: aBlock

	^executionPath getTransitionNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:31'!
id
	^id! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:31'!
id: newValue
	id := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 15:46'!
initialize

	super initialize.

	id := Lag1MwcRandom new integer.
	executionPath := BpmProcessPathDefinition definition: self.
	roles := Dictionary new.
	participants := Dictionary new.
	version := 1.
	subProcesses := Dictionary new.
	processInstances := Dictionary new.
	formFieldInstances := Dictionary new.! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 09:35'!
isSubProcess

	^parentProcess notNil! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 09:35'!
isTopProcess

	^parentProcess isNil! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
orbeonApplication
	^orbeonApplication! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
orbeonApplication: newValue
	orbeonApplication := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
parentProcess
	^parentProcess! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
parentProcess: newValue
	parentProcess := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 15:45'!
participants
	^participants! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 15:45'!
participants: newValue
	participants := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:41'!
printArtifacts

	^executionPath printArtifacts! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:32'!
printTransitions

	^executionPath printTransitions! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
processInstances
	^processInstances! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
processInstances: newValue
	processInstances := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:31'!
processName
	^processName! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:31'!
processName: newValue
	processName := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
roles
	^roles! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
roles: newValue
	roles := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/30/2015 12:53'!
sheetName
	^sheetName! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/30/2015 12:53'!
sheetName: newValue
	sheetName := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:37'!
startEvent

	^executionPath startEvent! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:27'!
startEvent: aBpmStartEventDefinition

	^executionPath startEvent: aBpmStartEventDefinition! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcesses
	^subProcesses! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcesses: newValue
	subProcesses := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
version
	^version! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
version: newValue
	version := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/02/2015 14:27'!
xmlString
	^xmlString! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/02/2015 14:27'!
xmlString: newValue
	xmlString := newValue! !

BpmObject subclass: #BpmProcessPathDefinition
	instanceVariableNames: 'processDefinition transitions startEvent intermediateEvents endEvents tasks gateways subProcessTasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmProcessPathDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:12'!
definition: aBpmProcessDefinition

	^super new initialize
			processDefinition: aBpmProcessDefinition;
			yourself! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:25'!
addEndEvent: aBpmEndEventDefinition

	^endEvents at: aBpmEndEventDefinition name put: aBpmEndEventDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:18'!
addGateway: aBpmGatewayDefinition

	^gateways at: aBpmGatewayDefinition name put: aBpmGatewayDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:25'!
addIntermediateEvent: aBpmIntermediateEventDefinition

	^endEvents at: aBpmIntermediateEventDefinition name put: aBpmIntermediateEventDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:18'!
addSubProcessTask: aBpmSubProcessTaskDefinition

	^subProcessTasks at: aBpmSubProcessTaskDefinition name put: aBpmSubProcessTaskDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:17'!
addTask: aBpmTaskDefinition

	^tasks at: aBpmTaskDefinition name put: aBpmTaskDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:20'!
addTransition: aBpmTransitionDefinition

	^transitions add: aBpmTransitionDefinition! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
endEvents
	^endEvents! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
endEvents: newValue
	endEvents := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
gateways
	^gateways! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
gateways: newValue
	gateways := newValue! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 14:40'!
getAllArtifacts

	^(OrderedCollection with: startEvent),
			tasks asOrderedCollection,
			gateways asOrderedCollection,
			intermediateEvents asOrderedCollection,
			subProcessTasks asOrderedCollection,
			endEvents asOrderedCollection! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getEndEventNamed: aString ifNone: aBlock

	^endEvents at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:12'!
getGatewayNamed: aString ifNone: aBlock

	^gateways at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getIntermediateEventNamed: aString ifNone: aBlock

	^intermediateEvents at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfEndEvents

	^endEvents size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfGateways

	^gateways size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfIntermediateEvents

	^intermediateEvents size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfSubProcessTasks

	^subProcessTasks size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:01'!
getNumberOfTasks

	^tasks size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:01'!
getNumberOfTransitions

	^transitions size! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getSubProcessTaskNamed: aString ifNone: aBlock

	^subProcessTasks at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:12'!
getTaskNamed: aString ifNone: aBlock

	^tasks at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/30/2015 05:44'!
getTransitionNamed: aString ifNone: aBlock

	^transitions detect: [:each | each name = aString] ifNone: aBlock! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:25'!
initialize

	super initialize.

	transitions := OrderedCollection new.
	intermediateEvents := Dictionary new.	
	endEvents := Dictionary new.
	tasks := Dictionary new.
	gateways := Dictionary new.
	subProcessTasks := Dictionary new.! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
intermediateEvents
	^intermediateEvents! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
intermediateEvents: newValue
	intermediateEvents := newValue! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:39'!
printArtifacts
	| stream  |

	stream := WriteStream on: String new.

	self getAllArtifacts do: [:each | 
		each printOn: stream.
		stream nextPut: Character lf].

	^stream contents! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:32'!
printTransitions
	| stream  |

	stream := WriteStream on: String new.

	transitions do: [:each | 
		each printOn: stream.
		stream nextPut: Character lf].

	^stream contents! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:11'!
processDefinition
	^processDefinition! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:11'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
startEvent
	^startEvent! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
startEvent: newValue
	startEvent := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcessTasks
	^subProcessTasks! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcessTasks: newValue
	subProcessTasks := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
tasks
	^tasks! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
tasks: newValue
	tasks := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
transitions
	^transitions! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
transitions: newValue
	transitions := newValue! !

BpmObject subclass: #BpmRole
	instanceVariableNames: 'name users isAdmin orbeonApplication tasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmRole subclass: #BpmBackofficeRole
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:38'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:38'!
cache: aDictionary

	Cache := aDictionary! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeRole

	^true! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeUserAndAdmin

	^isAdmin! !

BpmRole subclass: #BpmFrontOfficeRole
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmFrontOfficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:46'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmFrontOfficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:46'!
cache: aDictionary

	Cache := aDictionary! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:39'!
getAllRoles
	| allRols |

	allRols := OrderedCollection new.

	(BpmFrontEndRole cache asOrderedCollection, BpmBackofficeRole cache asOrderedCollection) 
	do: [:each | allRols addAll: each].

	^allRols! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:39'!
getAnyRoleNamed: aString

	^self getAllRoles detect: [:each | each name = aString] ifNone: [nil]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:42'!
getRoleNamed: aString

	^self cache detect: [:each | each name = aString] ifNone: [nil]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:43'!
getRolsInApp: anOrbeonApplication

	^self getAllRoles select: [:each | each orbeonApplication == anOrbeonApplication]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:42'!
getRolsInAppName: appName

	^(self cache select: [:each | each orbeonApplication app = appName]) asOrderedCollection! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:38'!
initializeCache

	self cache: Dictionary new! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:43'!
newNamed: aString

	^super new initialize
			name: aString;
			yourself! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:38'!
addToCacheInAppName: aString
	"The receiver is added to the global Role cache for the an OrbeonApplication named <aString>"

	orbeonApplication := OrbeonApplication applicationNamed: aString ifNone: [^NoOrbeonAppException signal: 'No Orbeon Application named <', aString, '>'].

	"get the role's collection for the OrbeonApplication named <aString>"
	(self class cache includesKey: aString) ifFalse: [self class cache at: aString put: OrderedCollection new].

	^(self class cache at: aString) add: self! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:32'!
initialize

	super initialize.

	name := ''.
	users := Dictionary new.
	tasks := Dictionary new.
	isAdmin := false.! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
isAdmin
	^isAdmin! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
isAdmin: newValue
	isAdmin := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeRole

	^false! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeUserAndAdmin

	^false! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
name
	^name! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
name: newValue
	name := newValue! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
orbeonApplication
	^orbeonApplication! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
orbeonApplication: newValue
	orbeonApplication := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 19:37'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, ']'! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
tasks
	^tasks! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
tasks: newValue
	tasks := newValue! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
users
	^users! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
users: newValue
	users := newValue! !

BpmObject subclass: #BpmTaskLoop
	instanceVariableNames: 'taskDefinition startQuantity completionQuantity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTaskLoop subclass: #BpmMultiInstanceTaskLoop
	instanceVariableNames: 'loopCardinality isSequential'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmMultiInstanceTaskLoop commentStamp: 'BrunoBB 10/31/2015 10:59' prior: 0!
loopCardinality - anInteger expression!

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^loopCardinality! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 11:01'!
initialize

	super initialize.

	loopCardinality := nil. "anInteger expression"
	isSequential := true. "false --> instances are created in parralel"! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isMultiInstance

	^true! !

!BpmMultiInstanceTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:00'!
isSequential
	^isSequential! !

!BpmMultiInstanceTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:00'!
isSequential: newValue
	isSequential := newValue! !

!BpmMultiInstanceTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:00'!
loopCardinality
	^loopCardinality! !

!BpmMultiInstanceTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:00'!
loopCardinality: newValue
	loopCardinality := newValue! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:46'!
setLoop: aStringBlock

	loopCardinality := aStringBlock! !

BpmTaskLoop subclass: #BpmNoneTaskLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^nil! !

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isNone

	^true! !

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
setLoop: aStringBlock! !

BpmTaskLoop subclass: #BpmStandartTaskLoop
	instanceVariableNames: 'loopCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmStandartTaskLoop commentStamp: 'BrunoBB 10/31/2015 11:02' prior: 0!
loopCondition - aBoolean expression!

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^loopCondition! !

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isStandart

	^true! !

!BpmStandartTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 10:52'!
loopCondition
	^loopCondition! !

!BpmStandartTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 10:52'!
loopCondition: newValue
	loopCondition := newValue! !

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
setLoop: aStringBlock

	loopCondition := aStringBlock! !

!BpmTaskLoop class methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
for: aBpmTaskDefinition

	^super new initialize
		taskDefinition: aBpmTaskDefinition;
		yourself! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
completionQuantity
	^completionQuantity! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:02'!
completionQuantity: newValue
	completionQuantity := newValue! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	self subclassResponsibility! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 10:10'!
initialize

	super initialize.

	startQuantity := 1.
	completionQuantity := 1.! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isMultiInstance

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
isNone

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
isStandart

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:46'!
setLoop: aStringBlock

	self subclassResponsibility! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
startQuantity
	^startQuantity! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 11/02/2015 08:31'!
startQuantity: newValue

	newValue ifNil: [^startQuantity := 1]. "when this value is absent --> it can be assumed that is 1 -one-"

	startQuantity := newValue! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
taskDefinition
	^taskDefinition! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:02'!
taskDefinition: newValue
	taskDefinition := newValue! !

BpmObject subclass: #BpmTransitionDefinition
	instanceVariableNames: 'processDefinition name startArtifact endArtifact conditionToRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmTransitionDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:46'!
process: aBpmProcessDefinition

	^super new initialize
		processDefinition: aBpmProcessDefinition;
		yourself! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:31'!
addToParentProcess

	^processDefinition addTransition: self! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 13:08'!
conditionToRun
	^conditionToRun! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 13:08'!
conditionToRun: newValue
	conditionToRun := newValue! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
endArtifact
	^endArtifact! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
endArtifact: newValue
	endArtifact := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:08'!
hasCondition

	^conditionToRun notNil! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 13:55'!
name
	^name! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 13:55'!
name: newValue
	name := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:35'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, '] {(', startArtifact printOnType, ')',startArtifact name, '} >> {(', endArtifact printOnType, ')', endArtifact name, '}'.! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
processDefinition
	^processDefinition! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:11'!
setCondition: aString

	conditionToRun := BpmCodeCondition code: aString! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 12:22'!
setEndArtifact: aBpmArtifactDefinition

	endArtifact := aBpmArtifactDefinition.

	aBpmArtifactDefinition addInTransition: self! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 12:22'!
setStartArtifact: aBpmArtifactDefinition

	startArtifact := aBpmArtifactDefinition.

	aBpmArtifactDefinition addOutTransition: self! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
startArtifact
	^startArtifact! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
startArtifact: newValue
	startArtifact := newValue! !
